;************************************* Fibonacci.asm ************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Los trminos de la secuencia de Fibonacci son: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, ...
; En esta secuencia cada nmero es la suma de los dos trminos que le preceden. Por ejemplo,
; el trmino que sigue al 55 ser 34 + 55= 89.
;
; Obtener el ltimo trmino de la secuencia de Fibonacci menor de 256 y sacar ese valor
; por el puerto de salida. 
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK  0x0C
	Penultimo					; Ocupa la posicin 0x0C de RAM.
	Ultimo						; Ocupa la posicin 0x0D de RAM.
	Suma						; Ocupa la posicin 0x0E de RAM.
	ENDC

; ZONA DE CDIGOS ********************************************************************

	ORG 	0					; El programa comienza en la direccin 0.
Inicio
	bsf		STATUS,RP0			; Acceso al Banco 1.
	clrf	TRISB				; Las lneas del Puerto B se configuran como salida.
	bcf		STATUS,RP0			; Acceso al Banco 0.
Principal
	clrf	Penultimo			; Asigna 0 al penltimo trmino de Fibonacci y
	movlw	.1					; 1 al ltimo. Son las "semillas".
SigueSumando
	movwf	Ultimo				; Asigna (W) al (Ultimo) trmino de Fibonacci.
	addwf	Penultimo,W			; Suma trminos ltimo y penltimo.
	movwf	Suma				; (Suma)=(Penultimo)+(Ultimo).
	btfsc	STATUS,C			; C=0?, (W)<256?
	goto	Fin					; No, por tanto ha excedido del mximo y sale.
	movf	Ultimo,W			; S, por tanto el (Ultimo) pasa al (Penultimo).
	movwf	Penultimo
	movf	Suma,W				; Y la (Suma) al (Ultimo).
	goto	SigueSumando
Fin	
	movfw	Ultimo				; En (Ultimo) el trmino de Fibonacci buscado.
	movwf	PORTB				; Resultado se visualiza por el puerto de salida.
	sleep

	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
