;************************************ I2C_EEPROM_02.asm *******************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Lee un mensaje almacenado en la memoria 24LC256 y lo visualiza por la pantalla del
; mdulo LCD desplazndose hacia la izquierda.
; El mensaje tiene que haber sido grabado previamente mediante el IC-Prog o un software
; similar.Tambin se puede grabar mediante el procedimiento explicado en el programa 
; I2C_EEPROM_01.asm.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK	0x0C
	ENDC

PAGINA	EQU	0x00
		
; ZONA DE CDIGOS ********************************************************************

	ORG 	0
Inicio
	call	LCD_Inicializa
Principal
	movlw	PAGINA					; Lee a partir de la direccin 0 de esta pgina
	call	M24LC256_Mensaje_a_LCD	; de la memoria.
	call	Retardo_1s
	goto	Principal

	INCLUDE  <BUS_I2C.INC>			; Subrutinas de control del bus I2C.
	INCLUDE  <M24LC256.INC>			; Subrutinas de control de la memoria 24LC256.
	INCLUDE  <RETARDOS.INC>
	INCLUDE  <LCD_4BIT.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
