;********************************** Indexado_02B.asm *************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Repeticin del ejercicio Indexado_02.asm sobre la forma de implementar una tabla de 
; verdad, pero resuelto con ms eficacia.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

; ZONA DE CDIGOS ********************************************************************

	ORG 	0					; El programa comienza en la direccin 0.
Inicio
	bsf		STATUS,RP0			; Acceso al Banco 1.
	clrf	TRISB				; Las lneas del Puerto B se configuran como salida.
	movlw	b'00011111'			; Las 5 lneas del Puerto A se configuran como entrada.
	movwf	TRISA
	bcf		STATUS,RP0			; Acceso al Banco 0.
Principal
	bcf		STATUS,C			; Lee los sensores y los multiplica por 2
	rlf		PORTA,W				; aadiendo un "0" y desplazando hacia la izquierda.
	andlw	b'00001111'			; Se queda con los cuatro bits ms bajos
	addwf	PCL,F				; Salta a la configuracin adecuada.
	movlw 	b'01100001'			; Estado "Vacio" (configuracin 0).
	goto	ActivaSalida
	movlw 	b'01100010'			; Estado "Llenndose" (configuracin 1).
	goto	ActivaSalida
	movlw 	b'00010000'			; Estado "Alarma" (configuracin 2).
	goto	ActivaSalida
	movlw 	b'00100100'			; Estado "Lleno" (configuracin 3).
	goto	ActivaSalida
	movlw 	b'00010000'			; Estado "Alarma" (configuracin 4).
	goto	ActivaSalida
	movlw 	b'00010000'			; Estado "Alarma" (configuracin 5).
	goto	ActivaSalida
	movlw 	b'00010000'			; Estado "Alarma" (configuracin 6).
	goto	ActivaSalida
	movlw 	b'00001000'			; Estado "Rebose" (configuracin 7).
ActivaSalida
	movwf	PORTB				; Visualiza por el puerto de salida.
	goto 	Principal

	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
