;************************************** Indexado_03.asm *********************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Programa para comprobar el efecto de un uso incorrecto de la instruccin "addwf PCL,F".
; Se debe comprobar con el simulador del MPLAB.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

; ZONA DE CDIGOS ********************************************************************

	ORG 	0
Inicio
	goto	Principal			; Posicin 000h de memoria de programa.
	clrw						; Posicin 001h de memoria de programa.
	goto	Inicio				; Posicin 002h de memoria de programa.

	ORG	0xFE					; Fija la posicin de la memoria de programa en 0x0FE.
Principal
	movlw	.1					; Posicin 0FEh de memoria de programa.
	addwf	PCL,F				; Posicin 0FFh de memoria de programa.
	goto	Configuracion0		; Posicin 100h de memoria de programa.
	goto	Configuracion1		; Posicin 101h de memoria de programa.
	
; La intencin de la instruccin "addwf PCL,F" es saltar a la posicin de la instruccin 
; "goto Configuracion1", que est en la posicin 101h de memoria de programa pero, como
; el contenido del registro PCLATH no ha cambiado de valor, realmente salta a la posicin
; que indica el contador de programa que en este caso es (PC)=(PCLATH)(PCL) = 0001h, es 
; decir, ha  saltado a la posicin donde se encuentra la instruccin "clrw". El salto se
; ha descontrolado.

Configuracion0
Configuracion1

	END							; Fin del programa.
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
