;************************************** LCD_03.asm *************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Programa ejemplo para comprender la utilizacin de las subrutinas "LCD_ByteCompleto",
; "LCD_Byte", "LCD_Nibble" y "LCD_DosEspaciosBlancos"
;
; Para ello se van a utilizar sucesivamente y en este orden las subrutinas: 
; "LCD_ByteCompleto", "LCD_DosEspaciosBlancos", "LCD_Byte",
; "LCD_DosEspaciosBlancos" y "LCD_Nibble" para dos nmeros que sern:
;
; - En la primera lnea del LCD un nmero con el nibble alto no cero. Por ejemplo: 1Dh.
; - En la segunda lnea del LCD un nmero con el nibble alto igual a cero. Ejemplo: 0Dh.
;
; As por ejemplo, para los nmeros "1D" y "0D" se visualizara (donde "#" viene a
; significar espacio en blanco):
; "1D##1D##D"	(Primera lnea).
; "0D###D##D"	(Segunda lnea).
;       
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK	0x0C
	ENDC

NUM_NoCeroAlto	EQU	0x1D		; Nmero ejemplo nibble alto no cero.
NUM_CeroAlto		EQU	0x0D		; Nmero ejemplo nibble alto cero.

; ZONA DE CDIGOS ********************************************************************

	ORG	0
Inicio
	call	LCD_Inicializa
Principal
	movlw	NUM_NoCeroAlto
	call	LCD_ByteCompleto
	call	LCD_DosEspaciosBlancos
	movlw	NUM_NoCeroAlto
	call	LCD_Byte
	call	LCD_DosEspaciosBlancos
	movlw	NUM_NoCeroAlto
	call	LCD_Nibble
	call	LCD_Linea2				; Se sita en la segunda lnea.
	movlw	NUM_CeroAlto
	call	LCD_ByteCompleto
	call	LCD_DosEspaciosBlancos
	movlw	NUM_CeroAlto
	call	LCD_Byte
	call	LCD_DosEspaciosBlancos
	movlw	NUM_CeroAlto
	call	LCD_Nibble
	sleep

	INCLUDE  <LCD_4BIT.INC>
	INCLUDE  <RETARDOS.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
