;***************************** Librera "RS232MEN.INC" **********************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84A. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Estas subrutinas permiten transmitir mensajes desde el microcontrolador hacia el 
; ordenador a travs del puerto serie RS232.
;
; Subrutina "RS232_Mensaje" -------------------------------------------------------------
;
; Enva por el puerto serie el mensaje apuntado por el registro W y grabado en memoria
; de programa del PIC. El mensaje se visualizar en el monitor del ordenador. Esta
; subrutina sigue la estructura de funcionamiento similar a la ya conocida "LCD_Mensaje"
; para visualizacin de mensajes en pantallas de  modulos LCD.
;
	CBLOCK
	RS232_ApuntaCaracter			; Apunta al carcter a visualizar.
	RS232_ValorCaracter				; Valor ASCII del carcter a visualizar.
	ENDC

RS232_Mensaje
	movwf	RS232_ApuntaCaracter	; Posicin del primer carcter del mensaje.
	movlw	Mensajes				; Halla la posicin relativa del primer carcter
	subwf	RS232_ApuntaCaracter,F	; del mensaje respecto del comienzo de todos los
									; mensajes (identificados mediante la etiqueta
									; "Mensajes").
	decf	RS232_ApuntaCaracter,F	; Para compensar la posicin que ocupa la 
RS232_VisualizaOtroCaracter			; instruccin "addwf PCL,F".
	movf	RS232_ApuntaCaracter,W	; Apunta al carcter a visualizar.
	call	Mensajes				; Obtiene el cdigo ASCII del carcter apuntado.
	movwf	RS232_ValorCaracter		; Guarda el valor de carcter.
	movf	RS232_ValorCaracter,F	; Lo nico que hace es posicionar flag Z. En caso
	btfsc	STATUS,Z				; que sea "0x00", que es cdigo indicador final	
	goto	RS232_FinMensaje 		; de mensaje, sale fuera.
RS232_NoUltimoCaracter
	call	RS232_EnviaDato			; Visualiza el carcter ASCII ledo.
	incf	RS232_ApuntaCaracter,F	; Apunta a la posicin del siguiente carcter
	goto	RS232_VisualizaOtroCaracter	; dentro del mensaje.
RS232_FinMensaje
	return

; Subrutina "RS232_LineasBlanco" ------------------------------------------------
;
; Visualiza unas cuantas lneas en blanco en el monitor del ordenador.

	CBLOCK
	RS232_ContadorLineas
	ENDC

RS232_LineasBlanco
	movlw	d'10'					; Por ejemplo este nmero de lneas en
	movwf	RS232_ContadorLineas	; blanco.
R232_LineasBlancoLazo
	movlw	.10						; Cdigo del salto de lnea
	call	RS232_EnviaDato
	decfsz	RS232_ContadorLineas,F
	goto	R232_LineasBlancoLazo
	movlw	.13						; Cdigo del retorno de carro.
	call	RS232_EnviaDato			; Finaliza con un retorno de carro.
	return
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84A. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
