;************************************ RS232_01.asm **************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; En la pantalla del modulo LCD se visualizarn los caracteres que se reciban a travs del
; puerto serie del ordenador. Lo que se escriba por el teclado del ordenador aparecer en
; la pantalla del sistema con microcontrolador.
;
; Se utilizar un programa de comunicaciones para que el ordenador pueda enviar datos a
; travs de su puerto serie. Este programa puede ser el Hyperterminal de Windows o alguno
; similar.
;      
; ZONA DE DATOS *************************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK	0x0C
	ENDC

; ZONA DE CDIGOS ***********************************************************************

	ORG	0
Inicio
	call	LCD_Inicializa		; Inicializa el LCD y las lneas que se
	call	RS232_Inicializa	; van a utilizar en la comunicacin con el puerto
Principal						; serie RS232.
	call	RS232_LeeDato		; Espera recibir un carcter.
	call	LCD_Caracter	 	; Lo visualiza.
	goto	Principal			; Repite el proceso.

	INCLUDE  <RS232.INC>		; Subrutinas de control de la comunicacin con el
	INCLUDE  <LCD_4BIT.INC>		; puerto serie RS232 del ordenador.
	INCLUDE  <RETARDOS.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
