;************************************ RS232_05.asm **************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Este programa enva un mensaje grabado en la memoria de programa del microcontrolador al
; ordenador. Es decir, en el monitor del ordenador aparecer el mensaje grabado en el PIC.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK  0x0C
	ENDC

ENTER			EQU	.13			; Cdigo de tecla "Enter" o "Retorno de Carro".
CAMBIO_LINEA	EQU	.10			; Cdigo para el cambio de lnea.

; ZONA DE CDIGOS ********************************************************************

	ORG	0
Inicio
	call	LCD_Inicializa		; Inicializa el modulo LCD y las lneas que se
	call	RS232_Inicializa	; van a utilizar en la comunicacin con el puerto
Principal						; serie RS232.
	movlw	Mensaje0			; Carga la primera posicin del mensaje.
	call	RS232_Mensaje		; Lo visualiza en el ordenador.
	call	Retardo_5s
	goto	Principal
;
; "Mensajes" ----------------------------------------------------------------------------
;
Mensajes
	addwf	PCL,F
Mensaje0
	DT ENTER
	DT " En el I.E.S. ISAAC PERAL de Torrejon de Ardoz"
	DT ENTER, CAMBIO_LINEA
	DT "      se puede estudiar el Ciclo Formativo"
	DT ENTER, CAMBIO_LINEA
	DT "      DESARROLLO de PRODUCTOS ELECTRONICOS."
	DT CAMBIO_LINEA, CAMBIO_LINEA, CAMBIO_LINEA, 0x00 

	INCLUDE  <RS232.INC>
	INCLUDE  <RS232MEN.INC>
	INCLUDE  <LCD_4BIT.INC>
	INCLUDE  <RETARDOS.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
