;************************************ RS232_08.asm **************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Programa que visualiza en el modulo LCD el cdigo ASCII en formato hexadecimal de la
; tecla pulsada y tambin en el monitor del ordenador en formato decimal. Por ejemplo:
;    - 	Monitor del ordenador: " k-107", donde la "k" es la tecla pulsada y el "107" el
;		cdigo ASCII en formato decimal.
;    - 	Pantalla del LCD: " k-6B", donde la "k" es la tecla pulsada y el "6B" el
;		cdigo ASCII en formato hexadecimal.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK	0x0C
	GuardaDato
	ENDC

; ZONA DE CDIGOS ********************************************************************

	ORG	0
Inicio
	call	LCD_Inicializa
	call	RS232_Inicializa
Principal
	call	RS232_LeeDato		; Espera recibir un carcter.
	movwf	GuardaDato			; Guarda el dato recibido.
	call	LCD_Borra			; Despeja la pantalla del visualizador LCD.
	movf	GuardaDato,W		; Recupera el dato ledo.
	call	LCD_Caracter		; Visualiza el carcter de la tecla pulsada.
	movlw	'-'					; Visualiza el guin.
	call	LCD_Caracter
	movf	GuardaDato,W
	call	LCD_ByteCompleto	; Visualiza en el LCD el cdigo ASCII.
	movf	GuardaDato,W		; Visualiza en la pantalla del ordenador el 
	call	RS232_EnviaDato		; carcter pulsado.
	movlw	'-'					; Visualiza en el ordenador el guin.
	call	RS232_EnviaDato
	movf	GuardaDato,W		; Lo pasa a BCD antes de visualizarlo.
	call	BIN_a_BCD
	movf	BCD_Centenas,W		; Visualiza el resultado en la pantalla  del
	call	RS232_EnviaNumero	; ordenador comenzando por las centenas.
	movf	BCD_Decenas,W
	call	RS232_EnviaNumero
	movf	BCD_Unidades,W
	call	RS232_EnviaNumero
	movlw	' '					; Enva un espacio en blanco para separarlo del
	call	RS232_EnviaDato		; anterior.
	goto	Principal
;
	INCLUDE  <RS232.INC>
	INCLUDE  <LCD_4BIT.INC>
	INCLUDE  <RETARDOS.INC>
	INCLUDE  <BIN_BCD.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
