;************************************ Retardo_04.asm ************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Por la barra de diodos LED conectada al puerto de salida, un led encendido rota a la
; izquierda 0,3 s en cada posicin. Cuando llega al final se apagan todos los LEDs y
; repite de nuevo la operacin.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK  0x0C
	ENDC

; ZONA DE CDIGOS ********************************************************************

	ORG	0
Inicio
	bsf		STATUS,RP0				; Acceso al Banco 1.
	clrf	PORTB					; Lneas del Puerto B se configuran como salidas.
	bcf		STATUS,RP0				; Acceso al Banco 0.
	bsf		STATUS,C				; Carga el dato inicial en el Carry
	clrf	PORTB					; y en la salida.
Principal
 	call	Retardo_200ms
	call	Retardo_100ms			; Un retardo total de 300 ms.
	rlf		PORTB,F					; Rota un lugar a la izquierda. 
	goto 	Principal

	INCLUDE  <RETARDOS.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
