;************************************* Tablas_07.asm *************************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; Repetir el ejercicio Tablas_03.asm, pero situando la tabla en una posicin tal que desborde
; la pgina de las primeras 256 posiciones de memoria de programa ROM.
;
; ZONA DE DATOS **********************************************************************

	LIST		P=16F84A
	INCLUDE		<P16F84A.INC>
	__CONFIG	_CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC
	
	CBLOCK 0x0C
	GuardaOffset
	ENDC

; ZONA DE CDIGOS ********************************************************************

	ORG 	0					; El programa comienza en la direccin 0.
Inicio
	bsf		STATUS,RP0			; Acceso al Banco 1.
	clrf	TRISB				; Las lneas del Puerto B se configuran como salida.
	movlw	b'00011111'			; Las 5 lneas del Puerto A se configuran como entrada.
	movwf	TRISA
	bcf		STATUS,RP0			; Acceso al Banco 0.
Principal
	movf	PORTA,W				; Lee el valor de las variables de entrada.
	andlw	b'00000111'			; Se queda con los tres bits bajos de entrada.
	movwf	GuardaOffset		; Guarda el offset del salto.	
	movlw	LOW (TablaVerdad+1)	; Obtiene los 8 bits bajos de la direccin de memoria
								; de programa donde est situada la tabla real.
	addwf	GuardaOffset,F		; Y halla el valor del salto absoluto dentro de la tabla.
	movlw	HIGH (TablaVerdad+1); Cinco bits alto de la direccin de memoria de
								; programa donde est situada la tabla real.
	btfsc	STATUS,C			; Ha desbordado la pgina de 256 bytes?
	addlw	1					; S, entonces aade una unidad al PCH.
	movwf	PCLATH				; Prepara el PCLATH.
	movf	GuardaOffset,W		; El offset se cargar en el PCL.
	call	TablaVerdad 		; Obtiene la configuracin de salida.
	movwf	PORTB				; Se visualiza por el puerto de salida.
	goto 	Principal

; Subrutina "TablaVerdad" ---------------------------------------------------------------
;
; La tabla de la verdad se sita desbordando los primeros 256 bytes de memoria de programa.

	ORG	.254					; Cerca del borde de la primera pgina de 256 bytes.

TablaVerdad						; Posicin 0x00FE de memoria de programa (PCH-PCL).
	movwf	PCL					; El salto dentro de la tabla: PCH=PCLATH, PCL=W.
								; (Ver figura 9-8).
	retlw 	b'00001010'			; (Configuracin 0). Posicin 0x00FF.
	retlw 	b'00001001'			; (Configuracin 1). Posicin 0x0100.
	retlw 	b'00100011'			; (Configuracin 2). Posicin 0x0101.
	retlw 	b'00001111'			; (Configuracin 3). Posicin 0x0102.
	retlw 	b'00100000'			; (Configuracin 4). Posicin 0x0103.
	retlw 	b'00000111'			; (Configuracin 5). Posicin 0x0104.
	retlw 	b'00010111'			; (Configuracin 6). Posicin 0x0105.
	retlw 	b'00111111'			; (Configuracin 7). Posicin 0x0106.

	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
