;************************************** Teclado_06.asm ********************************
;
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
;
; En pantalla aparecen el cdigo de las teclas que se van pulsando. Cuando llega al final
; de la primera lnea, pasa a la segunda lnea. Cuando llega al final de la segunda lneatodo y
; borra comienza de nuevo al principio de la lnea 1.
;
; ZONA DE DATOS *********************************************************************

	LIST	   P=16F84A
	INCLUDE  <P16F84A.INC>
	__CONFIG   _CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

	CBLOCK  0x0C
	GuardaTecla						; Guarda el valor de la tecla pulsada.
	ContadorCaracteres				; Guarda el nmero de caracteres pulsados.
	ENDC

NUM_UNA_LINEA	EQU	d'16'		; Nmero de caracteres de una lnea.
NUM_DOS_LINEAS  EQU	d'32'		; Nmero de caracteres de dos lneas.

; ZONA DE CDIGOS ********************************************************************

	ORG	0
	goto 	Inicio
	ORG	4
	goto	ServicioInterrupcion
Inicio
	call	LCD_Inicializa
	call	Teclado_Inicializa		; Configura lneas del teclado.
	movlw	b'10001000'				; Habilita la interrupcin RBI y la general.
	movwf	INTCON
	clrf	ContadorCaracteres		; En principio no hay caracteres escritos.
Principal
	sleep							; Espera en modo bajo consumo que pulse tecla.
	goto	Principal

; Subrutina "ServicioInterrupcion" ------------------------------------------------------
;
ServicioInterrupcion
	call	Teclado_LeeHex			; Obtiene el valor de la tecla pulsada.
	movwf	GuardaTecla				; Reserva el valor de la tecla pulsada.
	movlw	NUM_UNA_LINEA			; Comprueba si ha llegado al nmero mximo de
	subwf	ContadorCaracteres,W	; caracteres de una lnea.
	btfsc	STATUS,Z
	call	LCD_Linea2				; Se sita en la segunda lnea.
	movlw	NUM_DOS_LINEAS			; Comprueba si ha llegado al nmero mximo de
	subwf	ContadorCaracteres,W	; caracteres de dos lneas.
	btfss	STATUS,Z
	goto	EscribeCaracter			; No, por tanto, sigue escribiendo.
	call	LCD_Borra				; S, borra pantalla e inicializa el contador.
	clrf	ContadorCaracteres
EscribeCaracter	
	incf	ContadorCaracteres,F	; Un nuevo carcter escrito.
	movf	GuardaTecla,W
	call	LCD_Nibble				; Visualiza el carcter en pantalla.
	call	Teclado_EsperaDejePulsar; Para que no se repita el mismo carcter.
	bcf		INTCON,RBIF				; Limpia flag.
	retfie

	INCLUDE  <TECLADO.INC>
	INCLUDE  <LCD_4BIT.INC>
	INCLUDE  <RETARDOS.INC>
	END
	
;	===================================================================
;	  Del libro "MICROCONTROLADOR PIC16F84. DESARROLLO DE PROYECTOS"
;	  E. Palacios, F. Remiro y L. Lpez.		www.pic16f84a.com
; 	  Editorial Ra-Ma.  www.ra-ma.es
;	===================================================================
